/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cd.hologram.erecettesvg.sql;

/**
 *
 * @author moussa.toure
 */
public class SQLQueryFractionnement {

    public static final String SAVE_DEMANDE_ECHELONNEMENT = ":EXEC F_NEW_DEMANDE_ECHELONNEMENT ?1,?2,?3,?4,?5,?6,?7,?8,?9";

    public static final String SAVE_DETAIL_ECHELONNEMENT = ":EXEC F_NEW_DETAILS_ECHELONNEMENT ?1,?2,'%s'";

    public static final String VALIDER_DEMANDE_ECHELONNEMENT = ":EXEC F_VALIDATION_ECHELONNEMENT ?1,?2,?3,?4,?5,?6,?7,?8";

    public static final String SELECT_DEMANDE_ECHELONNEMENT_MASTER = "SELECT DE.* FROM T_DEMANDE_ECHELONNEMENT DE "
            + " WITH (READPAST) WHERE DE.ETAT %s %s %s %s ORDER BY DE.DATE_CREAT DESC,DE.CODE DESC";

//    public static final String SELECT_DEMANDE_ECHELONNEMENT_MASTER_ADVANCED = "SELECT * FROM T_DEMANDE_ECHELONNEMENT DE WITH (READPAST) "
//            + " WHERE CODE IN (SELECT FK_DEMANDE_ECHELONNEMENT FROM T_DETAIL_ECHELONNEMENT WHERE ETAT %s AND (NUMERO_TITRE IN (("
//            + " SELECT NP.NUMERO FROM T_NOTE_PERCEPTION NP  WITH (READPAST) WHERE NP.SITE IN (%s) AND "
//            + " NP.NOTE_CALCUL IN (SELECT  NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.SERVICE IN (%s)))) "
//            + " OR NUMERO_TITRE IN (SELECT BP.CODE FROM T_BON_A_PAYER BP WITH (READPAST) WHERE BP.FK_SITE IN (%s) AND \n"
//            + " BP.FK_NOTE_CALCUL IN (SELECT  NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.SERVICE IN (%s)))))"
//            + " AND DBO.FDATE(DE.DATE_CREAT) BETWEEN '%s' AND '%s' %s ORDER BY DE.DATE_CREAT DESC,DE.CODE DESC";
    
    public static final String SELECT_DEMANDE_ECHELONNEMENT_MASTER_ADVANCED = "SELECT * FROM T_DEMANDE_ECHELONNEMENT DE WITH (READPAST) "
            + " WHERE CODE IN (SELECT FK_DEMANDE_ECHELONNEMENT FROM T_DETAIL_ECHELONNEMENT WHERE ETAT %s AND (NUMERO_TITRE IN (("
            + " SELECT NP.NUMERO FROM T_NOTE_PERCEPTION NP  WITH (READPAST) WHERE %s"
            + " NP.NOTE_CALCUL IN (SELECT  NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST)))) "
            + " OR NUMERO_TITRE IN (SELECT BP.CODE FROM T_BON_A_PAYER BP WITH (READPAST) WHERE \n"
            + " BP.FK_NOTE_CALCUL IN (SELECT  NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST)))))"
            + " AND DBO.FDATE(DE.DATE_CREAT) BETWEEN '%s' AND '%s' ORDER BY DE.DATE_CREAT DESC,DE.CODE DESC";
    
    public static final String SELECT_DEMANDE_ECHELONNEMENT_BY_PERSONNE = "SELECT * FROM T_DEMANDE_ECHELONNEMENT DE WITH (READPAST) "
            + " WHERE CODE IN (SELECT FK_DEMANDE_ECHELONNEMENT FROM T_DETAIL_ECHELONNEMENT WHERE ETAT %s AND (NUMERO_TITRE IN (("
            + " SELECT NP.NUMERO FROM T_NOTE_PERCEPTION NP  WITH (READPAST) WHERE NP.SITE IN (%s) AND "
            + " NP.NOTE_CALCUL IN (SELECT  NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.PERSONNE = ?1 AND NC.SERVICE IN (%s)))) "
            + " OR NUMERO_TITRE IN (SELECT BP.CODE FROM T_BON_A_PAYER BP WITH (READPAST) WHERE BP.FK_SITE IN (%s) AND \n"
            + " BP.FK_NOTE_CALCUL IN (SELECT  NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.PERSONNE = ?1 AND NC.SERVICE IN (%s)))))"
            + " %s ORDER BY DE.DATE_CREAT DESC,DE.CODE DESC";

    public static final String SELECT_DEMANDE_ECHELONNEMENT_MASTER_BY_TITRE = "SELECT * FROM T_DEMANDE_ECHELONNEMENT DE WITH (READPAST) "
            + " WHERE CODE IN (SELECT FK_DEMANDE_ECHELONNEMENT FROM T_DETAIL_ECHELONNEMENT WHERE ETAT %s AND (NUMERO_TITRE = ?1 AND NUMERO_TITRE IN (("
            + " SELECT NP.NUMERO FROM T_NOTE_PERCEPTION NP  WITH (READPAST) WHERE NP.SITE IN (%s) AND "
            + " NP.NOTE_CALCUL IN (SELECT  NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.SERVICE IN (%s)))) "
            + " OR NUMERO_TITRE = ?1 AND NUMERO_TITRE IN (SELECT BP.CODE FROM T_BON_A_PAYER BP WITH (READPAST) WHERE  BP.FK_SITE IN (%s) AND \n"
            + " BP.FK_NOTE_CALCUL IN (SELECT  NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE  NC.SERVICE IN (%s)))))"
            + " %s ORDER BY DE.DATE_CREAT DESC,DE.CODE DESC";

    public static final String SELECT_DEMANDE_ECHELONNEMENT_MASTER_LETTRE = "SELECT * FROM T_DEMANDE_ECHELONNEMENT DE WITH (READPAST) "
            + " WHERE CODE IN (SELECT FK_DEMANDE_ECHELONNEMENT FROM T_DETAIL_ECHELONNEMENT WHERE ETAT %s AND (NUMERO_TITRE IN (("
            + " SELECT NP.NUMERO FROM T_NOTE_PERCEPTION NP  WITH (READPAST) WHERE NP.SITE IN (%s) AND "
            + " NP.NOTE_CALCUL IN (SELECT  NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.SERVICE IN (%s)))) "
            + " OR NUMERO_TITRE IN (SELECT BP.CODE FROM T_BON_A_PAYER BP WITH (READPAST) WHERE  BP.FK_SITE IN (%s) AND \n"
            + " BP.FK_NOTE_CALCUL IN (SELECT  NC.NUMERO FROM T_NOTE_CALCUL NC WITH (READPAST) WHERE NC.SERVICE IN (%s)))))"
            + " AND REFERENCE_LETTRE = ?1 %s ORDER BY DE.DATE_CREAT DESC,DE.CODE DESC ";
    

    public static final String SELECT_LIST_NP_FILLE_BY_NP_MERE = "SELECT NP.* FROM T_NOTE_PERCEPTION NP WITH (READPAST) "
            + " WHERE NP.NP_MERE = ?1 AND NP.ETAT IN (0,1,2) AND FK_TYPE_TITRE_PERCEPTION = 2 ORDER BY NP.DATE_ECHEANCE_PAIEMENT ";

    public static final String SELECT_LIST_BP_FILLE_BY_NP_MERE = "SELECT BP.* FROM T_BON_A_PAYER BP WITH (READPAST) WHERE BP.BP_MERE = ?1 "
            + "AND BP.TYPE_BP = 2 AND BP.ETAT IN (0,1) ORDER BY BP.DATE_ECHEANCE ";

    public static String SELECT_DEMANDE_ECHELONNEMENT_BY_CODE = "SELECT DE.* FROM T_DEMANDE_ECHELONNEMENT DE "
            + " WITH (READPAST) WHERE DE.CODE = ?1 AND DE.ETAT <> 0";

    public static String SELECT_DEMANDE_ECHELONNEMENT_BY_NP = "SELECT DE.* FROM T_DEMANDE_ECHELONNEMENT DE "
            + " WITH (READPAST) WHERE DE.FK_NP = ?1";

    public static String SELECT_DEMANDE_ECHELONNEMENT_BY_TITRE = "SELECT * FROM T_DEMANDE_ECHELONNEMENT (READPAST) "
            + " WHERE CODE IN (SELECT FK_DEMANDE_ECHELONNEMENT FROM T_DETAIL_ECHELONNEMENT WHERE NUMERO_TITRE = ?1)";

    public static String F_UPDATE_NP_MERE_EST_FRACTIONNEE = ":UPDATE T_NOTE_PERCEPTION SET FRACTIONNEE = 1 WHERE NUMERO = ?1";

    public static String F_NEW_NOTE_PERCEPTION_INTERCALAIRE = ":EXEC F_NEW_NOTE_PERCEPTION_INTERCALAIRE ?1,?2,?3,?4,?5,?6,"
            + " ?7,?8,?9,?10,?11,12,?13,?14,?15,?16";

    public static String F_CLOSE_NP_ECHELONNEE = ":UPDATE T_NOTE_PERCEPTION SET ETAT = 0 WHERE NUMERO = ?1 ";

    public static String F_VALIDATE_DEMANDE_ECHELONNEMENT_AFTER_ORDONNANCEMENT = ":UPDATE T_DEMANDE_ECHELONNEMENT "
            + " SET ETAT = 4 WHERE CODE = ?1";
    
    public static String F_UPDATE_NOTES_PERCEPTIONS_FRACTIONNEES = ":UPDATE T_NOTE_PERCEPTION SET ETAT = 1 WHERE NP_MERE = ?1";

    public static String F_UPDATE_DETAIL_ECHELONNEMENT_AFTER_ORDONNANCEMENT = ":UPDATE T_DETAIL_ECHELONNEMENT SET ETAT = 4 "
            + " WHERE NUMERO_TITRE = ?1 AND FK_DEMANDE_ECHELONNEMENT = ?2";

    public static String F_UPDATE_NUMERO_MANUEL_NOTE_INTERCALIERE = ":UPDATE T_NOTE_PERCEPTION SET NP_MANUEL = ?1, SITE = ?2 WHERE NUMERO = ?3";

    public static String F_UPDATE_NUMERO_MANUEL_BON_A_PAYER = ":UPDATE T_BON_A_PAYER SET BP_MANUEL = ?1 WHERE CODE = ?2";

    public static String F_ANNULATION_DEMANDE_ECHELONNEMENT_AFTER_REVOCATION = ":UPDATE T_DEMANDE_ECHELONNEMENT "
            + " SET ETAT = 3 WHERE CODE = ?1";

    public static String F_ANNULATION_DETAILS_ECHELONNEMENT_AFTER_REVOCATION = ":UPDATE T_DETAIL_ECHELONNEMENT "
            + " SET ETAT = 3 WHERE FK_DEMANDE_ECHELONNEMENT = ?1";

    public static String F_CLOTURE_NC_PENALITE = ":UPDATE T_NOTE_CALCUL SET DATE_CLOTURE = ?1, AGENT_CLOTURE = ?2,"
            + " OBSERVATION = ?3, ETAT = ?4 WHERE NUMERO = ?5";

    public static String F_CLOTURE_NC_PENALITE_V1 = ":UPDATE T_NOTE_CALCUL SET DATE_CLOTURE = ?1, AGENT_CLOTURE = ?2,"
            + " OBSERVATION = ?3, ETAT = ?4 WHERE NUMERO = '%s'";

    public static String F_UPDATE_DATE_LIMITE_REVOCATION = ":UPDATE T_NOTE_CALCUL SET DATE_LIMITE_REVOCATION = ?1 WHERE NUMERO = ?2";
    public static String F_UPDATE_DATE_LIMITE_REVOCATION_V1 = ":UPDATE T_NOTE_CALCUL SET DATE_LIMITE_REVOCATION = ?1 WHERE NUMERO = '%s'";

    public static String SELECT_NOTE_PERCEPTION_INTERCALAIRE_BY_NUMERO = "SELECT NP.* FROM T_NOTE_PERCEPTION NP "
            + " WITH (READPAST) WHERE NP.NUMERO = ?1";

    public static String SELECT_NP_MERE_BY_NP_INTERCALAIRE = "SELECT NP.* FROM T_NOTE_PERCEPTION NP "
            + " WITH (READPAST) WHERE NP.NUMERO = ?1";

    public static String SELECT_BON_A_PAYER_BY_NOTE_CALCUL = "SELECT BP.* FROM T_BON_A_PAYER BP  WITH (READPAST) "
            + " WHERE BP.FK_NOTE_CALCUL = ?1";

    public static String SELECT_BON_A_PAYER_BY_NOTE_CALCUL_PAYED = "SELECT BP.* FROM T_BON_A_PAYER BP  WITH (READPAST) "
            + " WHERE BP.FK_NOTE_CALCUL = ?1 AND BP.CODE NOT IN (SELECT DOCUMENT_APURE FROM T_JOURNAL WHERE DOCUMENT_APURE = BP.CODE AND ETAT = 1) ORDER BY CODE";

    public static String F_CLOSE_BON_A_PAYER = ":UPDATE T_BON_A_PAYER SET ETAT = 0 WHERE CODE = ?1";

    public static String F_UPDATE_NC_OF_BON_A_PAYER_BY_NEW_NC = ":UPDATE T_BON_A_PAYER SET FK_NOTE_CALCUL = ?1 WHERE FK_NOTE_CALCUL = ?2";

    public static String F_UPDATE_NC_OF_BON_A_PAYER_BY_NEW_NC_V1 = ":UPDATE T_BON_A_PAYER SET FK_NOTE_CALCUL = '%s' WHERE FK_NOTE_CALCUL = ?1";

    public static String SELECT_LIST_ARCHIVE_BY_REFERENCE = "SELECT * FROM T_ARCHIVE_ACCUSE_RECEPTION AR  WITH (READPAST) "
            + " WHERE AR.DOCUMENT_REFERENCE = ?1";

    public static String SELECT_BON_A_PAYER_FROM_FRACTION_BY_NOTE_CALCUL = "SELECT BP.* FROM T_BON_A_PAYER BP  WITH (READPAST) "
            + " WHERE BP.FK_NOTE_CALCUL = ?1 AND BP.FROM_FRACTION = 1 AND BP.ETAT = 1 ORDER BY CODE";

    public static String SELECT_BON_A_PAYER_FROM_FRACTION_BY_NOTE_CALCUL_NOT_PAYED = "SELECT BP.* FROM T_BON_A_PAYER BP  WITH (READPAST) "
            + " WHERE BP.FK_NOTE_CALCUL = ?1 AND BP.CODE NOT IN (SELECT DOCUMENT_APURE FROM T_JOURNAL WHERE DOCUMENT_APURE = BP.CODE AND ETAT = 1) "
            + " AND BP.FROM_FRACTION = 1 AND BP.ETAT=1 ORDER BY CODE";

    public static String SELECT_BON_A_PAYER_INTERET_BY_NP_NOT_PAYED = "SELECT BP.* FROM T_BON_A_PAYER BP  WITH (READPAST) "
            + " WHERE BP.CODE NOT IN (SELECT DOCUMENT_APURE FROM T_JOURNAL WHERE DOCUMENT_APURE = BP.CODE AND ETAT = 1) "
            + " AND BP.NP_MERE = ?1 AND BP.TYPE_BP = 3 ORDER BY CODE";

    public static String SELECT_BON_A_PAYER_INTERET_BY_BP_NOT_PAYED = "SELECT BP.* FROM T_BON_A_PAYER BP  WITH (READPAST) "
            + " WHERE BP.CODE NOT IN (SELECT DOCUMENT_APURE FROM T_JOURNAL WHERE DOCUMENT_APURE = BP.CODE AND ETAT = 1) "
            + " AND BP.TYPE_BP = 3 AND BP.BP_MERE = ?1 ORDER BY CODE";

    public static String UPDATE_NP_FRACTIONNER = ":UPDATE T_NOTE_PERCEPTION "
            + " SET FRACTIONNEE = 1 WHERE NUMERO = ?1";
    
        public static String UPDATE_ECHEANCE_PROROGATION_NP_v2 = ":UPDATE T_NOTE_PERCEPTION "
            + " SET DATE_ECHEANCE_PAIEMENT = ?1 WHERE NP_MANUEL = ?2";

    public static String UPDATE_ECHEANCE_PROROGATION_NP = ":UPDATE T_NOTE_PERCEPTION "
            + " SET DATE_ECHEANCE_PAIEMENT = ?1 WHERE NUMERO = ?2";

    public static String UPDATE_ECHEANCE_PROROGATION_BP = ":UPDATE T_BON_A_PAYER "
            + " SET DATE_ECHEANCE = ?1 WHERE CODE = ?2";
    
        public static String UPDATE_ECHEANCE_PROROGATION_BP_V2 = ":UPDATE T_BON_A_PAYER "
            + " SET DATE_ECHEANCE = ?1 WHERE BP_MANUEL = ?2";

    public static String UPDATE_NC_REDRESSE = ":UPDATE T_NOTE_CALCUL SET FK_NC_REDRESSE = '%s' WHERE NUMERO = ?1";
}
